plotPostPredField = function (observed,stanFit, modelname=""){
  #plots the posterior predictive 
  
 
  #exclude observations > 200
   #include=observed<200
   #observed=observed[include]
  
  #add yitter
  observed=log(observed)#+runif(min=-2, max=+2, n=length(observed)))
  post=extract(stanFit)
  pointpred=post$pred#[,include]
  stdev=post$std
  nJagsSamples=dim(pointpred)[1]
  
  
  #generate n predictions for each of the observations
  n=10000
  subsample=sample(1:nJagsSamples, size=n)
  
  pred=matrix(NA, nrow=length(observed), ncol=n)
  hpd95=matrix(NA, nrow=length(observed), ncol=2)
  for(i in 1:length(observed)){
    pred[i,]=rnorm(mean=log(pointpred[subsample,i]), sd=stdev[subsample], n=n)#exp(rnorm(mean=log(pointpred[subsample,i]), sd=stdev[subsample], n=n))
    hpd95[i,]=HPDinterval(as.mcmc(pred[i,]))
  }
  medianPred=apply(pred,1,median)
 
  plot(NULL, xlim=range(observed,hpd95), ylim=range(observed,hpd95), main="Posterior Predictive Fit", 
       xlab="Observed value (log scale)", ylab= "Model prediction/ HPD95 (log scale)",
       xaxt="n", yaxt="n")
  
  axisLabels=c(5,10,25,50 ,100,200,400)
  axis(1, at=c(0,log(axisLabels)), labels=c(0,axisLabels))
  axis(2, at=c(0,log(axisLabels)), labels=c(0,axisLabels))
    
  arrows(x0=observed,x1=observed,y0=hpd95[,1], y1=hpd95[,2], angle=90, length=0, code=3)
  points(observed, medianPred, col="blue")
  abline(0,1, col="red")
  
  
  mtext(modelname)
}